#include "../librpc/gen_ndr/ndr_efs.h"
#ifndef __CLI_EFS__
#define __CLI_EFS__
struct tevent_req *rpccli_EfsRpcOpenFileRaw_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct rpc_pipe_client *cli,
						 struct policy_handle *_pvContext /* [out] [ref] */,
						 const char *_FileName /* [in] [charset(UTF16)] */,
						 uint32_t _Flags /* [in]  */);
NTSTATUS rpccli_EfsRpcOpenFileRaw_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       WERROR *result);
NTSTATUS rpccli_EfsRpcOpenFileRaw(struct rpc_pipe_client *cli,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *pvContext /* [out] [ref] */,
				  const char *FileName /* [in] [charset(UTF16)] */,
				  uint32_t Flags /* [in]  */,
				  WERROR *werror);
struct tevent_req *rpccli_EfsRpcReadFileRaw_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct rpc_pipe_client *cli,
						 struct policy_handle *_pvContext /* [in] [ref] */);
NTSTATUS rpccli_EfsRpcReadFileRaw_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       WERROR *result);
NTSTATUS rpccli_EfsRpcReadFileRaw(struct rpc_pipe_client *cli,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *pvContext /* [in] [ref] */,
				  WERROR *werror);
struct tevent_req *rpccli_EfsRpcWriteFileRaw_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct rpc_pipe_client *cli,
						  struct policy_handle *_pvContext /* [in] [ref] */);
NTSTATUS rpccli_EfsRpcWriteFileRaw_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					WERROR *result);
NTSTATUS rpccli_EfsRpcWriteFileRaw(struct rpc_pipe_client *cli,
				   TALLOC_CTX *mem_ctx,
				   struct policy_handle *pvContext /* [in] [ref] */,
				   WERROR *werror);
struct tevent_req *rpccli_EfsRpcCloseRaw_send(TALLOC_CTX *mem_ctx,
					      struct tevent_context *ev,
					      struct rpc_pipe_client *cli,
					      struct policy_handle *_pvContext /* [in,out] [ref] */);
NTSTATUS rpccli_EfsRpcCloseRaw_recv(struct tevent_req *req,
				    TALLOC_CTX *mem_ctx);
NTSTATUS rpccli_EfsRpcCloseRaw(struct rpc_pipe_client *cli,
			       TALLOC_CTX *mem_ctx,
			       struct policy_handle *pvContext /* [in,out] [ref] */);
struct tevent_req *rpccli_EfsRpcEncryptFileSrv_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct rpc_pipe_client *cli,
						    const char *_Filename /* [in] [charset(UTF16)] */);
NTSTATUS rpccli_EfsRpcEncryptFileSrv_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  WERROR *result);
NTSTATUS rpccli_EfsRpcEncryptFileSrv(struct rpc_pipe_client *cli,
				     TALLOC_CTX *mem_ctx,
				     const char *Filename /* [in] [charset(UTF16)] */,
				     WERROR *werror);
struct tevent_req *rpccli_EfsRpcDecryptFileSrv_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct rpc_pipe_client *cli,
						    const char *_FileName /* [in] [charset(UTF16)] */,
						    uint32_t _Reserved /* [in]  */);
NTSTATUS rpccli_EfsRpcDecryptFileSrv_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  WERROR *result);
NTSTATUS rpccli_EfsRpcDecryptFileSrv(struct rpc_pipe_client *cli,
				     TALLOC_CTX *mem_ctx,
				     const char *FileName /* [in] [charset(UTF16)] */,
				     uint32_t Reserved /* [in]  */,
				     WERROR *werror);
struct tevent_req *rpccli_EfsRpcQueryUsersOnFile_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct rpc_pipe_client *cli,
						      const char *_FileName /* [in] [charset(UTF16)] */,
						      struct ENCRYPTION_CERTIFICATE_HASH_LIST **_pUsers /* [out] [unique,ref] */);
NTSTATUS rpccli_EfsRpcQueryUsersOnFile_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    WERROR *result);
NTSTATUS rpccli_EfsRpcQueryUsersOnFile(struct rpc_pipe_client *cli,
				       TALLOC_CTX *mem_ctx,
				       const char *FileName /* [in] [charset(UTF16)] */,
				       struct ENCRYPTION_CERTIFICATE_HASH_LIST **pUsers /* [out] [unique,ref] */,
				       WERROR *werror);
struct tevent_req *rpccli_EfsRpcQueryRecoveryAgents_send(TALLOC_CTX *mem_ctx,
							 struct tevent_context *ev,
							 struct rpc_pipe_client *cli,
							 const char *_FileName /* [in] [charset(UTF16)] */,
							 struct ENCRYPTION_CERTIFICATE_HASH_LIST **_pRecoveryAgents /* [out] [unique,ref] */);
NTSTATUS rpccli_EfsRpcQueryRecoveryAgents_recv(struct tevent_req *req,
					       TALLOC_CTX *mem_ctx,
					       WERROR *result);
NTSTATUS rpccli_EfsRpcQueryRecoveryAgents(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  const char *FileName /* [in] [charset(UTF16)] */,
					  struct ENCRYPTION_CERTIFICATE_HASH_LIST **pRecoveryAgents /* [out] [unique,ref] */,
					  WERROR *werror);
struct tevent_req *rpccli_EfsRpcRemoveUsersFromFile_send(TALLOC_CTX *mem_ctx,
							 struct tevent_context *ev,
							 struct rpc_pipe_client *cli,
							 const char *_FileName /* [in] [charset(UTF16)] */);
NTSTATUS rpccli_EfsRpcRemoveUsersFromFile_recv(struct tevent_req *req,
					       TALLOC_CTX *mem_ctx,
					       WERROR *result);
NTSTATUS rpccli_EfsRpcRemoveUsersFromFile(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  const char *FileName /* [in] [charset(UTF16)] */,
					  WERROR *werror);
struct tevent_req *rpccli_EfsRpcAddUsersToFile_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct rpc_pipe_client *cli,
						    const char *_FileName /* [in] [charset(UTF16)] */);
NTSTATUS rpccli_EfsRpcAddUsersToFile_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  WERROR *result);
NTSTATUS rpccli_EfsRpcAddUsersToFile(struct rpc_pipe_client *cli,
				     TALLOC_CTX *mem_ctx,
				     const char *FileName /* [in] [charset(UTF16)] */,
				     WERROR *werror);
struct tevent_req *rpccli_EfsRpcSetFileEncryptionKey_send(TALLOC_CTX *mem_ctx,
							  struct tevent_context *ev,
							  struct rpc_pipe_client *cli,
							  struct ENCRYPTION_CERTIFICATE *_pEncryptionCertificate /* [in] [unique] */);
NTSTATUS rpccli_EfsRpcSetFileEncryptionKey_recv(struct tevent_req *req,
						TALLOC_CTX *mem_ctx,
						WERROR *result);
NTSTATUS rpccli_EfsRpcSetFileEncryptionKey(struct rpc_pipe_client *cli,
					   TALLOC_CTX *mem_ctx,
					   struct ENCRYPTION_CERTIFICATE *pEncryptionCertificate /* [in] [unique] */,
					   WERROR *werror);
struct tevent_req *rpccli_EfsRpcNotSupported_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct rpc_pipe_client *cli);
NTSTATUS rpccli_EfsRpcNotSupported_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					WERROR *result);
NTSTATUS rpccli_EfsRpcNotSupported(struct rpc_pipe_client *cli,
				   TALLOC_CTX *mem_ctx,
				   WERROR *werror);
struct tevent_req *rpccli_EfsRpcFileKeyInfo_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct rpc_pipe_client *cli);
NTSTATUS rpccli_EfsRpcFileKeyInfo_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       WERROR *result);
NTSTATUS rpccli_EfsRpcFileKeyInfo(struct rpc_pipe_client *cli,
				  TALLOC_CTX *mem_ctx,
				  WERROR *werror);
struct tevent_req *rpccli_EfsRpcDuplicateEncryptionInfoFile_send(TALLOC_CTX *mem_ctx,
								 struct tevent_context *ev,
								 struct rpc_pipe_client *cli);
NTSTATUS rpccli_EfsRpcDuplicateEncryptionInfoFile_recv(struct tevent_req *req,
						       TALLOC_CTX *mem_ctx,
						       WERROR *result);
NTSTATUS rpccli_EfsRpcDuplicateEncryptionInfoFile(struct rpc_pipe_client *cli,
						  TALLOC_CTX *mem_ctx,
						  WERROR *werror);
#endif /* __CLI_EFS__ */
