/*
 * Unix SMB/CIFS implementation.
 * client auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/cli_oxidresolver.h"

struct rpccli_ResolveOxid_state {
	struct ResolveOxid orig;
	struct ResolveOxid tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_ResolveOxid_done(struct tevent_req *subreq);

struct tevent_req *rpccli_ResolveOxid_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli,
					   uint64_t _pOxid /* [in]  */,
					   uint16_t _cRequestedProtseqs /* [in]  */,
					   uint16_t *_arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
					   struct DUALSTRINGARRAY **_ppdsaOxidBindings /* [out] [ref] */,
					   struct GUID *_pipidRemUnknown /* [out] [ref] */,
					   uint32_t *_pAuthnHint /* [out] [ref] */)
{
	struct tevent_req *req;
	struct rpccli_ResolveOxid_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_ResolveOxid_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */
	state->orig.in.pOxid = _pOxid;
	state->orig.in.cRequestedProtseqs = _cRequestedProtseqs;
	state->orig.in.arRequestedProtseqs = _arRequestedProtseqs;

	/* Out parameters */
	state->orig.out.ppdsaOxidBindings = _ppdsaOxidBindings;
	state->orig.out.pipidRemUnknown = _pipidRemUnknown;
	state->orig.out.pAuthnHint = _pAuthnHint;

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	state->out_mem_ctx = talloc_named_const(state, 0,
			     "rpccli_ResolveOxid_out_memory");
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_RESOLVEOXID,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_ResolveOxid_done, req);
	return req;
}

static void rpccli_ResolveOxid_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_ResolveOxid_state *state = tevent_req_data(
		req, struct rpccli_ResolveOxid_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */
	*state->orig.out.ppdsaOxidBindings = *state->tmp.out.ppdsaOxidBindings;
	*state->orig.out.pipidRemUnknown = *state->tmp.out.pipidRemUnknown;
	*state->orig.out.pAuthnHint = *state->tmp.out.pAuthnHint;

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_ResolveOxid_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result)
{
	struct rpccli_ResolveOxid_state *state = tevent_req_data(
		req, struct rpccli_ResolveOxid_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_ResolveOxid(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t pOxid /* [in]  */,
			    uint16_t cRequestedProtseqs /* [in]  */,
			    uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			    struct DUALSTRINGARRAY **ppdsaOxidBindings /* [out] [ref] */,
			    struct GUID *pipidRemUnknown /* [out] [ref] */,
			    uint32_t *pAuthnHint /* [out] [ref] */,
			    WERROR *werror)
{
	struct ResolveOxid r;
	NTSTATUS status;

	/* In parameters */
	r.in.pOxid = pOxid;
	r.in.cRequestedProtseqs = cRequestedProtseqs;
	r.in.arRequestedProtseqs = arRequestedProtseqs;

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_RESOLVEOXID,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*ppdsaOxidBindings = *r.out.ppdsaOxidBindings;
	*pipidRemUnknown = *r.out.pipidRemUnknown;
	*pAuthnHint = *r.out.pAuthnHint;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

struct rpccli_SimplePing_state {
	struct SimplePing orig;
	struct SimplePing tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_SimplePing_done(struct tevent_req *subreq);

struct tevent_req *rpccli_SimplePing_send(TALLOC_CTX *mem_ctx,
					  struct tevent_context *ev,
					  struct rpc_pipe_client *cli,
					  uint64_t *_SetId /* [in] [ref] */)
{
	struct tevent_req *req;
	struct rpccli_SimplePing_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_SimplePing_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */
	state->orig.in.SetId = _SetId;

	/* Out parameters */

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_SIMPLEPING,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_SimplePing_done, req);
	return req;
}

static void rpccli_SimplePing_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_SimplePing_state *state = tevent_req_data(
		req, struct rpccli_SimplePing_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_SimplePing_recv(struct tevent_req *req,
				TALLOC_CTX *mem_ctx,
				WERROR *result)
{
	struct rpccli_SimplePing_state *state = tevent_req_data(
		req, struct rpccli_SimplePing_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_SimplePing(struct rpc_pipe_client *cli,
			   TALLOC_CTX *mem_ctx,
			   uint64_t *SetId /* [in] [ref] */,
			   WERROR *werror)
{
	struct SimplePing r;
	NTSTATUS status;

	/* In parameters */
	r.in.SetId = SetId;

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SIMPLEPING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

struct rpccli_ComplexPing_state {
	struct ComplexPing orig;
	struct ComplexPing tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_ComplexPing_done(struct tevent_req *subreq);

struct tevent_req *rpccli_ComplexPing_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli,
					   uint64_t *_SetId /* [in,out] [ref] */,
					   uint16_t _SequenceNum /* [in]  */,
					   uint16_t _cAddToSet /* [in]  */,
					   uint16_t _cDelFromSet /* [in]  */,
					   struct GUID *_AddToSet /* [in] [size_is(cAddToSet)] */,
					   struct GUID *_DelFromSet /* [in] [size_is(cDelFromSet)] */,
					   uint16_t *_PingBackoffFactor /* [out] [ref] */)
{
	struct tevent_req *req;
	struct rpccli_ComplexPing_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_ComplexPing_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */
	state->orig.in.SetId = _SetId;
	state->orig.in.SequenceNum = _SequenceNum;
	state->orig.in.cAddToSet = _cAddToSet;
	state->orig.in.cDelFromSet = _cDelFromSet;
	state->orig.in.AddToSet = _AddToSet;
	state->orig.in.DelFromSet = _DelFromSet;

	/* Out parameters */
	state->orig.out.SetId = _SetId;
	state->orig.out.PingBackoffFactor = _PingBackoffFactor;

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	state->out_mem_ctx = talloc_named_const(state, 0,
			     "rpccli_ComplexPing_out_memory");
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_COMPLEXPING,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_ComplexPing_done, req);
	return req;
}

static void rpccli_ComplexPing_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_ComplexPing_state *state = tevent_req_data(
		req, struct rpccli_ComplexPing_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */
	*state->orig.out.SetId = *state->tmp.out.SetId;
	*state->orig.out.PingBackoffFactor = *state->tmp.out.PingBackoffFactor;

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_ComplexPing_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result)
{
	struct rpccli_ComplexPing_state *state = tevent_req_data(
		req, struct rpccli_ComplexPing_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_ComplexPing(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t *SetId /* [in,out] [ref] */,
			    uint16_t SequenceNum /* [in]  */,
			    uint16_t cAddToSet /* [in]  */,
			    uint16_t cDelFromSet /* [in]  */,
			    struct GUID *AddToSet /* [in] [size_is(cAddToSet)] */,
			    struct GUID *DelFromSet /* [in] [size_is(cDelFromSet)] */,
			    uint16_t *PingBackoffFactor /* [out] [ref] */,
			    WERROR *werror)
{
	struct ComplexPing r;
	NTSTATUS status;

	/* In parameters */
	r.in.SetId = SetId;
	r.in.SequenceNum = SequenceNum;
	r.in.cAddToSet = cAddToSet;
	r.in.cDelFromSet = cDelFromSet;
	r.in.AddToSet = AddToSet;
	r.in.DelFromSet = DelFromSet;

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_COMPLEXPING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*SetId = *r.out.SetId;
	*PingBackoffFactor = *r.out.PingBackoffFactor;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

struct rpccli_ServerAlive_state {
	struct ServerAlive orig;
	struct ServerAlive tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_ServerAlive_done(struct tevent_req *subreq);

struct tevent_req *rpccli_ServerAlive_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli)
{
	struct tevent_req *req;
	struct rpccli_ServerAlive_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_ServerAlive_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */

	/* Out parameters */

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_SERVERALIVE,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_ServerAlive_done, req);
	return req;
}

static void rpccli_ServerAlive_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_ServerAlive_state *state = tevent_req_data(
		req, struct rpccli_ServerAlive_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_ServerAlive_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result)
{
	struct rpccli_ServerAlive_state *state = tevent_req_data(
		req, struct rpccli_ServerAlive_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_ServerAlive(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    WERROR *werror)
{
	struct ServerAlive r;
	NTSTATUS status;

	/* In parameters */

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SERVERALIVE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

struct rpccli_ResolveOxid2_state {
	struct ResolveOxid2 orig;
	struct ResolveOxid2 tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_ResolveOxid2_done(struct tevent_req *subreq);

struct tevent_req *rpccli_ResolveOxid2_send(TALLOC_CTX *mem_ctx,
					    struct tevent_context *ev,
					    struct rpc_pipe_client *cli,
					    uint64_t _pOxid /* [in]  */,
					    uint16_t _cRequestedProtseqs /* [in]  */,
					    uint16_t *_arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
					    struct DUALSTRINGARRAY **_pdsaOxidBindings /* [out] [ref] */,
					    struct GUID *_ipidRemUnknown /* [out] [ref] */,
					    uint32_t *_AuthnHint /* [out] [ref] */,
					    struct COMVERSION *_ComVersion /* [out] [ref] */)
{
	struct tevent_req *req;
	struct rpccli_ResolveOxid2_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_ResolveOxid2_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */
	state->orig.in.pOxid = _pOxid;
	state->orig.in.cRequestedProtseqs = _cRequestedProtseqs;
	state->orig.in.arRequestedProtseqs = _arRequestedProtseqs;

	/* Out parameters */
	state->orig.out.pdsaOxidBindings = _pdsaOxidBindings;
	state->orig.out.ipidRemUnknown = _ipidRemUnknown;
	state->orig.out.AuthnHint = _AuthnHint;
	state->orig.out.ComVersion = _ComVersion;

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	state->out_mem_ctx = talloc_named_const(state, 0,
			     "rpccli_ResolveOxid2_out_memory");
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_RESOLVEOXID2,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_ResolveOxid2_done, req);
	return req;
}

static void rpccli_ResolveOxid2_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_ResolveOxid2_state *state = tevent_req_data(
		req, struct rpccli_ResolveOxid2_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */
	*state->orig.out.pdsaOxidBindings = *state->tmp.out.pdsaOxidBindings;
	*state->orig.out.ipidRemUnknown = *state->tmp.out.ipidRemUnknown;
	*state->orig.out.AuthnHint = *state->tmp.out.AuthnHint;
	*state->orig.out.ComVersion = *state->tmp.out.ComVersion;

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_ResolveOxid2_recv(struct tevent_req *req,
				  TALLOC_CTX *mem_ctx,
				  WERROR *result)
{
	struct rpccli_ResolveOxid2_state *state = tevent_req_data(
		req, struct rpccli_ResolveOxid2_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_ResolveOxid2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     uint64_t pOxid /* [in]  */,
			     uint16_t cRequestedProtseqs /* [in]  */,
			     uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			     struct DUALSTRINGARRAY **pdsaOxidBindings /* [out] [ref] */,
			     struct GUID *ipidRemUnknown /* [out] [ref] */,
			     uint32_t *AuthnHint /* [out] [ref] */,
			     struct COMVERSION *ComVersion /* [out] [ref] */,
			     WERROR *werror)
{
	struct ResolveOxid2 r;
	NTSTATUS status;

	/* In parameters */
	r.in.pOxid = pOxid;
	r.in.cRequestedProtseqs = cRequestedProtseqs;
	r.in.arRequestedProtseqs = arRequestedProtseqs;

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_RESOLVEOXID2,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*pdsaOxidBindings = *r.out.pdsaOxidBindings;
	*ipidRemUnknown = *r.out.ipidRemUnknown;
	*AuthnHint = *r.out.AuthnHint;
	*ComVersion = *r.out.ComVersion;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

struct rpccli_ServerAlive2_state {
	struct ServerAlive2 orig;
	struct ServerAlive2 tmp;
	TALLOC_CTX *out_mem_ctx;
	NTSTATUS (*dispatch_recv)(struct tevent_req *req, TALLOC_CTX *mem_ctx);
};

static void rpccli_ServerAlive2_done(struct tevent_req *subreq);

struct tevent_req *rpccli_ServerAlive2_send(TALLOC_CTX *mem_ctx,
					    struct tevent_context *ev,
					    struct rpc_pipe_client *cli,
					    struct COMINFO *_info /* [out] [ref] */,
					    struct DUALSTRINGARRAY *_dualstring /* [out] [ref] */,
					    uint8_t *_unknown2 /* [out] [ref] */,
					    uint8_t *_unknown3 /* [out] [ref] */,
					    uint8_t *_unknown4 /* [out] [ref] */)
{
	struct tevent_req *req;
	struct rpccli_ServerAlive2_state *state;
	struct tevent_req *subreq;

	req = tevent_req_create(mem_ctx, &state,
				struct rpccli_ServerAlive2_state);
	if (req == NULL) {
		return NULL;
	}
	state->out_mem_ctx = NULL;
	state->dispatch_recv = cli->dispatch_recv;

	/* In parameters */

	/* Out parameters */
	state->orig.out.info = _info;
	state->orig.out.dualstring = _dualstring;
	state->orig.out.unknown2 = _unknown2;
	state->orig.out.unknown3 = _unknown3;
	state->orig.out.unknown4 = _unknown4;

	/* Result */
	ZERO_STRUCT(state->orig.out.result);

	state->out_mem_ctx = talloc_named_const(state, 0,
			     "rpccli_ServerAlive2_out_memory");
	if (tevent_req_nomem(state->out_mem_ctx, req)) {
		return tevent_req_post(req, ev);
	}

	/* make a temporary copy, that we pass to the dispatch function */
	state->tmp = state->orig;

	subreq = cli->dispatch_send(state, ev, cli,
				    &ndr_table_IOXIDResolver,
				    NDR_SERVERALIVE2,
				    &state->tmp);
	if (tevent_req_nomem(subreq, req)) {
		return tevent_req_post(req, ev);
	}
	tevent_req_set_callback(subreq, rpccli_ServerAlive2_done, req);
	return req;
}

static void rpccli_ServerAlive2_done(struct tevent_req *subreq)
{
	struct tevent_req *req = tevent_req_callback_data(
		subreq, struct tevent_req);
	struct rpccli_ServerAlive2_state *state = tevent_req_data(
		req, struct rpccli_ServerAlive2_state);
	NTSTATUS status;
	TALLOC_CTX *mem_ctx;

	if (state->out_mem_ctx) {
		mem_ctx = state->out_mem_ctx;
	} else {
		mem_ctx = state;
	}

	status = state->dispatch_recv(subreq, mem_ctx);
	TALLOC_FREE(subreq);
	if (!NT_STATUS_IS_OK(status)) {
		tevent_req_nterror(req, status);
		return;
	}

	/* Copy out parameters */
	*state->orig.out.info = *state->tmp.out.info;
	*state->orig.out.dualstring = *state->tmp.out.dualstring;
	*state->orig.out.unknown2 = *state->tmp.out.unknown2;
	*state->orig.out.unknown3 = *state->tmp.out.unknown3;
	*state->orig.out.unknown4 = *state->tmp.out.unknown4;

	/* Copy result */
	state->orig.out.result = state->tmp.out.result;

	/* Reset temporary structure */
	ZERO_STRUCT(state->tmp);

	tevent_req_done(req);
}

NTSTATUS rpccli_ServerAlive2_recv(struct tevent_req *req,
				  TALLOC_CTX *mem_ctx,
				  WERROR *result)
{
	struct rpccli_ServerAlive2_state *state = tevent_req_data(
		req, struct rpccli_ServerAlive2_state);
	NTSTATUS status;

	if (tevent_req_is_nterror(req, &status)) {
		tevent_req_received(req);
		return status;
	}

	/* Steal possbile out parameters to the callers context */
	talloc_steal(mem_ctx, state->out_mem_ctx);

	/* Return result */
	*result = state->orig.out.result;

	tevent_req_received(req);
	return NT_STATUS_OK;
}

NTSTATUS rpccli_ServerAlive2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     struct COMINFO *info /* [out] [ref] */,
			     struct DUALSTRINGARRAY *dualstring /* [out] [ref] */,
			     uint8_t *unknown2 /* [out] [ref] */,
			     uint8_t *unknown3 /* [out] [ref] */,
			     uint8_t *unknown4 /* [out] [ref] */,
			     WERROR *werror)
{
	struct ServerAlive2 r;
	NTSTATUS status;

	/* In parameters */

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SERVERALIVE2,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*info = *r.out.info;
	*dualstring = *r.out.dualstring;
	*unknown2 = *r.out.unknown2;
	*unknown3 = *r.out.unknown3;
	*unknown4 = *r.out.unknown4;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

