
/* Python wrapper functions auto-generated by pidl */
#include "includes.h"
#include <Python.h>
#include "librpc/rpc/dcerpc.h"
#include "lib/talloc/pytalloc.h"
#include "librpc/rpc/pyrpc.h"
#include "../librpc/gen_ndr/ndr_dsbackup.h"
#include "../librpc/gen_ndr/ndr_dsbackup_c.h"

#ifndef Py_RETURN_NONE
#define Py_RETURN_NONE return Py_INCREF(Py_None), Py_None
#endif

staticforward PyTypeObject ad_backup_InterfaceType;

staticforward PyTypeObject ad_restore_InterfaceType;


const struct PyNdrRpcMethodDef py_ndr_ad_backup_methods[] = {
	{ "HrRBackupPrepare", NULL, (dcerpc_call_fn)dcerpc_HrRBackupPrepare, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 0, &ndr_table_ad_backup },
	{ "HrRBackupEnd", NULL, (dcerpc_call_fn)dcerpc_HrRBackupEnd, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 1, &ndr_table_ad_backup },
	{ "HrRBackupGetAttachmentInformation", NULL, (dcerpc_call_fn)dcerpc_HrRBackupGetAttachmentInformation, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 2, &ndr_table_ad_backup },
	{ "HrRBackupOpenFile", NULL, (dcerpc_call_fn)dcerpc_HrRBackupOpenFile, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 3, &ndr_table_ad_backup },
	{ "HrRBackupRead", NULL, (dcerpc_call_fn)dcerpc_HrRBackupRead, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 4, &ndr_table_ad_backup },
	{ "HrRBackupClose", NULL, (dcerpc_call_fn)dcerpc_HrRBackupClose, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 5, &ndr_table_ad_backup },
	{ "HrRBackupGetBackupLogs", NULL, (dcerpc_call_fn)dcerpc_HrRBackupGetBackupLogs, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 6, &ndr_table_ad_backup },
	{ "HrRBackupTruncateLogs", NULL, (dcerpc_call_fn)dcerpc_HrRBackupTruncateLogs, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 7, &ndr_table_ad_backup },
	{ "HrRBackupPing", NULL, (dcerpc_call_fn)dcerpc_HrRBackupPing, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 8, &ndr_table_ad_backup },
	{ NULL }
};

static PyObject *interface_ad_backup_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_ad_backup);
}

#define PY_DOC_AD_BACKUP "Backup support for Active Directory"
static PyTypeObject ad_backup_InterfaceType = {
	PyObject_HEAD_INIT(NULL) 0,
	.tp_name = "dsbackup.ad_backup",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_base = &dcerpc_InterfaceType,
	.tp_doc = "ad_backup(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n"PY_DOC_AD_BACKUP,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_ad_backup_new,
};


const struct PyNdrRpcMethodDef py_ndr_ad_restore_methods[] = {
	{ "HrRIsNTDSOnline", NULL, (dcerpc_call_fn)dcerpc_HrRIsNTDSOnline, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 0, &ndr_table_ad_restore },
	{ "HrRRestorePrepare", NULL, (dcerpc_call_fn)dcerpc_HrRRestorePrepare, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 1, &ndr_table_ad_restore },
	{ "HrRRestoreRegister", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreRegister, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 2, &ndr_table_ad_restore },
	{ "HrRRestoreRegisterComplete", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreRegisterComplete, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 3, &ndr_table_ad_restore },
	{ "HrRRestoreGetDatabaseLocations", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreGetDatabaseLocations, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 4, &ndr_table_ad_restore },
	{ "HrRRestoreEnd", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreEnd, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 5, &ndr_table_ad_restore },
	{ "HrRRestoreSetCurrentLogNumber", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreSetCurrentLogNumber, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 6, &ndr_table_ad_restore },
	{ "HrRRestoreCheckLogsForBackup", NULL, (dcerpc_call_fn)dcerpc_HrRRestoreCheckLogsForBackup, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 7, &ndr_table_ad_restore },
	{ NULL }
};

static PyObject *interface_ad_restore_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_ad_restore);
}

#define PY_DOC_AD_RESTORE "Restoring Active Directory backups"
static PyTypeObject ad_restore_InterfaceType = {
	PyObject_HEAD_INIT(NULL) 0,
	.tp_name = "dsbackup.ad_restore",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_base = &dcerpc_InterfaceType,
	.tp_doc = "ad_restore(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n"PY_DOC_AD_RESTORE,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_ad_restore_new,
};

static PyMethodDef dsbackup_methods[] = {
	{ NULL, NULL, 0, NULL }
};

void initdsbackup(void)
{
	PyObject *m;

	if (PyType_Ready(&ad_backup_InterfaceType) < 0)
		return;
	if (PyType_Ready(&ad_restore_InterfaceType) < 0)
		return;
	if (!PyInterface_AddNdrRpcMethods(&ad_backup_InterfaceType, py_ndr_ad_backup_methods))
		return;

	if (!PyInterface_AddNdrRpcMethods(&ad_restore_InterfaceType, py_ndr_ad_restore_methods))
		return;

#ifdef PY_AD_BACKUP_PATCH
	PY_AD_BACKUP_PATCH(&ad_backup_InterfaceType);
#endif
#ifdef PY_AD_RESTORE_PATCH
	PY_AD_RESTORE_PATCH(&ad_restore_InterfaceType);
#endif

	m = Py_InitModule3("dsbackup", dsbackup_methods, "dsbackup DCE/RPC");
	if (m == NULL)
		return;

	Py_INCREF((PyObject *)&ad_backup_InterfaceType);
	PyModule_AddObject(m, "ad_backup", (PyObject *)&ad_backup_InterfaceType);
	Py_INCREF((PyObject *)&ad_restore_InterfaceType);
	PyModule_AddObject(m, "ad_restore", (PyObject *)&ad_restore_InterfaceType);
#ifdef PY_MOD_DSBACKUP_PATCH
	PY_MOD_DSBACKUP_PATCH(m);
#endif

}
