
/* Python wrapper functions auto-generated by pidl */
#include "includes.h"
#include <Python.h>
#include "librpc/rpc/dcerpc.h"
#include "lib/talloc/pytalloc.h"
#include "librpc/rpc/pyrpc.h"
#include "../librpc/gen_ndr/ndr_msgsvc.h"
#include "../librpc/gen_ndr/ndr_msgsvc_c.h"

#ifndef Py_RETURN_NONE
#define Py_RETURN_NONE return Py_INCREF(Py_None), Py_None
#endif

staticforward PyTypeObject msgsvc_InterfaceType;

staticforward PyTypeObject msgsvcsend_InterfaceType;


const struct PyNdrRpcMethodDef py_ndr_msgsvc_methods[] = {
	{ "NetrMessageNameAdd", NULL, (dcerpc_call_fn)dcerpc_NetrMessageNameAdd, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 0, &ndr_table_msgsvc },
	{ "NetrMessageNameEnum", NULL, (dcerpc_call_fn)dcerpc_NetrMessageNameEnum, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 1, &ndr_table_msgsvc },
	{ "NetrMessageNameGetInfo", NULL, (dcerpc_call_fn)dcerpc_NetrMessageNameGetInfo, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 2, &ndr_table_msgsvc },
	{ "NetrMessageNameDel", NULL, (dcerpc_call_fn)dcerpc_NetrMessageNameDel, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 3, &ndr_table_msgsvc },
	{ NULL }
};

static PyObject *interface_msgsvc_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_msgsvc);
}

#define PY_DOC_MSGSVC "Messaging Service"
static PyTypeObject msgsvc_InterfaceType = {
	PyObject_HEAD_INIT(NULL) 0,
	.tp_name = "msgsvc.msgsvc",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_base = &dcerpc_InterfaceType,
	.tp_doc = "msgsvc(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n"PY_DOC_MSGSVC,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_msgsvc_new,
};


const struct PyNdrRpcMethodDef py_ndr_msgsvcsend_methods[] = {
	{ "NetrSendMessage", NULL, (dcerpc_call_fn)dcerpc_NetrSendMessage, (py_data_pack_fn)NULL, (py_data_unpack_fn)NULL, 0, &ndr_table_msgsvcsend },
	{ NULL }
};

static PyObject *interface_msgsvcsend_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return py_dcerpc_interface_init_helper(type, args, kwargs, &ndr_table_msgsvcsend);
}

static PyTypeObject msgsvcsend_InterfaceType = {
	PyObject_HEAD_INIT(NULL) 0,
	.tp_name = "msgsvc.msgsvcsend",
	.tp_basicsize = sizeof(dcerpc_InterfaceObject),
	.tp_base = &dcerpc_InterfaceType,
	.tp_doc = "msgsvcsend(binding, lp_ctx=None, credentials=None) -> connection\n"
"\n"
"binding should be a DCE/RPC binding string (for example: ncacn_ip_tcp:127.0.0.1)\n"
"lp_ctx should be a path to a smb.conf file or a param.LoadParm object\n"
"credentials should be a credentials.Credentials object.\n\n",
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = interface_msgsvcsend_new,
};

static PyMethodDef msgsvc_methods[] = {
	{ NULL, NULL, 0, NULL }
};

void initmsgsvc(void)
{
	PyObject *m;

	if (PyType_Ready(&msgsvc_InterfaceType) < 0)
		return;
	if (PyType_Ready(&msgsvcsend_InterfaceType) < 0)
		return;
	if (!PyInterface_AddNdrRpcMethods(&msgsvc_InterfaceType, py_ndr_msgsvc_methods))
		return;

	if (!PyInterface_AddNdrRpcMethods(&msgsvcsend_InterfaceType, py_ndr_msgsvcsend_methods))
		return;

#ifdef PY_MSGSVC_PATCH
	PY_MSGSVC_PATCH(&msgsvc_InterfaceType);
#endif
#ifdef PY_MSGSVCSEND_PATCH
	PY_MSGSVCSEND_PATCH(&msgsvcsend_InterfaceType);
#endif

	m = Py_InitModule3("msgsvc", msgsvc_methods, "msgsvc DCE/RPC");
	if (m == NULL)
		return;

	Py_INCREF((PyObject *)&msgsvc_InterfaceType);
	PyModule_AddObject(m, "msgsvc", (PyObject *)&msgsvc_InterfaceType);
	Py_INCREF((PyObject *)&msgsvcsend_InterfaceType);
	PyModule_AddObject(m, "msgsvcsend", (PyObject *)&msgsvcsend_InterfaceType);
#ifdef PY_MOD_MSGSVC_PATCH
	PY_MOD_MSGSVC_PATCH(m);
#endif

}
